#include <bits/stdc++.h>
using namespace std;
const int mn=2*1e5+100;
pair<int,int> l[mn];
pair<int,int> r[mn];

int L[mn];
int R[mn];
int kolki[mn];
//PRVO FENVIKOVO

int fenvik[mn];
void update(int x,int n)
{
    while(x<=n)
    {
        fenvik[x]++;
        x+=x&(-x);
    }
}

int sum(int pos)
{
    int res=0;
    while(pos>=1)
    {
        res+=fenvik[pos];
        pos-=pos&(-pos);
    }   
    return res;
}

//DRUGO FENVIKOVO

int fenvik1[mn];

void update1(int x,int n)
{
    while(x<=n)
    {
        fenvik1[x]++;
        x+=x&(-x);
    }
}

int sum1(int pos)
{
    int res=0;
    while(pos>=1)
    {
        res+=fenvik1[pos];
        pos-=pos&(-pos);
    }   
    return res;
}

vector<vector<int> > queries;
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n,m;
    cin>>n>>m;
    for(int i=1;i<=n;i++)
    {
        cin>>l[i].first;
        l[i].second=i;
        cin>>r[i].first;
        r[i].first=(r[i].first)*(-1);
        r[i].second=i;
    }
    sort(l+1,l+n+1);
    sort(r+1,r+n+1);
    /*for(int i=1;i<=n;i++) cout<<l[i].first<<" ";
    cout<<endl;
    for(int i=1;i<=n;i++) cout<<r[i].first<<" ";
    cout<<endl;*/
    for(int i=0;i<m;i++)
    {
        int l,r,x;
        cin>>l>>r>>x;
        kolki[i]=r-l+1;
        queries.push_back({x,l,r,i});
    }
    sort(queries.begin(),queries.end());
    reverse(queries.begin(),queries.end());
    //for(int i=0;i<queries.size();i++) cout<<queries[i][0]<<" ";
    //cout<<endl;
    int j=n;
    for(int i=0;i<m;i++)
    {
        while(j>=1 && l[j].first>queries[i][0])
        {
            update(l[j].second,n);
            j--;
        }
        L[queries[i][3]]=sum(queries[i][2])-sum(queries[i][1]-1);
    }

    j=n; //opet
    for(int i=m-1;i>=0;i--)
    {
        while(j>=1 && r[j].first>-queries[i][0])
        {
            update1(r[j].second,n);
            j--;
        }
        R[queries[i][3]]=sum1(queries[i][2])-sum1(queries[i][1]-1);
    }
    /*/for(int i=0;i<m;i++) cout<<L[i]<<" ";
    cout<<endl;
    for(int i=0;i<m;i++) cout<<R[i]<<" ";
    cout<<endl;*/
    for(int i=0;i<m;i++)
    {
        cout<<kolki[i]-R[i]-L[i]<<endl;
    }
}